image: docker:stable

services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay2
  REGISTRY_IMAGE: $CI_REGISTRY_IMAGE
  HUB_IMAGE: "smartgeosystems/golang_builder"


before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  - docker login -u $HUB_USER -p $HUB_TOKEN

build_master:
  stage: build
  script:
    # 20.04 1.3
    - docker build --pull --no-cache -t $REGISTRY_IMAGE:20.04-1.13 -t $HUB_IMAGE:20.04-1.13 20.04/1.13
    - docker push $REGISTRY_IMAGE:20.04-1.13
    - docker push $HUB_IMAGE:20.04-1.13
    # 20.04 1.16
    - docker build --pull --no-cache -t $REGISTRY_IMAGE:20.04-1.16 -t $HUB_IMAGE:20.04-1.16 20.04/1.16
    - docker push $REGISTRY_IMAGE:20.04-1.16
    - docker push $HUB_IMAGE:20.04-1.16
    # 22.04 1.17
    - docker build --pull --no-cache -t $REGISTRY_IMAGE:22.04-1.17 -t $HUB_IMAGE:22.04-1.17 22.04/1.17
    - docker push $REGISTRY_IMAGE:22.04-1.17
    - docker push $HUB_IMAGE:22.04-1.17
    # 22.04 1.18
    - docker build --pull --no-cache -t $REGISTRY_IMAGE:22.04-1.18 -t $HUB_IMAGE:22.04-1.18 22.04/1.18
    - docker push $REGISTRY_IMAGE:22.04-1.18
    - docker push $HUB_IMAGE:22.04-1.18
  only:
    - master
